function MemotooThunderbird() { this._init(); }

MemotooThunderbird.prototype = 
{
  settings:null,
  addressBook:null,
  stringbundle:null,
  _console:null,
  _ioService:null,

  _init:function() 
  {
    var sbSvc = Components.classes["@mozilla.org/intl/stringbundle;1"]
                .getService(Components.interfaces.nsIStringBundleService);
    this.stringbundle = sbSvc.createBundle("chrome://memotoothunderbird/locale/memotoothunderbird.properties");

    this._console = Components.classes["@mozilla.org/consoleservice;1"]
                    .getService(Components.interfaces.nsIConsoleService);

    this._ioService = Components.classes["@mozilla.org/network/io-service;1"]
                      .getService(Components.interfaces.nsIIOService);

    this.settings = new MemotooThunderbirdSettings(this);
  },
  
  get addressBookLDIF()
  {
    this.addressBook = new MemotooThunderbirdAddressBook(this);

    var source = "";
    source += "";

    return source;
  },

	uploadAddressBookLDIF:function()
  //get uploadAddressBookLDIF()
  {
  	var addressBookLDIFtmp = this.addressBookLDIF;
  	//alert(addressBookLDIFtmp);
/*  	
  	if (this.addressBook.addressBook.length>0)
  	{  	
	  	if (this.settings.prefLogin=="" || this.settings.prefPassword=="")
	  	{
	  		alert(this.stringbundle.GetStringFromName("loginpasswordempty"));
	  		return false;
	  	}

	  	var urlTmp = this.settings.prefUrl+"?l="+this.settings.prefLogin+"&p="+this.settings.prefPassword;
*/
/*	  	
	  	if (this.settings.prefIsDownloader)
	  		urlTmp = urlTmp+"&isdownloader=1";
	  	else
	  		urlTmp = urlTmp+"&isdownloader=0";
*/
	  	//alert(urlTmp);
/*	  	
	  	window.setCursor("wait");
	  	
	  	//gBookmarksSynchronizerUploadService.start(addressBookLDIFtmp, this._ioService.newURI(urlTmp, null, null), "text/html", uploadCallback);
*/
	  	alert("export");
/*
		}
		else
		{
			alert(this.stringbundle.GetStringFromName("upload0contact"));
			gMemotooThunderbird.settings.prefIsUploader = true;
		}
*/	
		return true;
  },

	downloadAddressBookLDIF:function()
  //get downloadAddressBookLDIF()
  {	
		if (this.settings.prefLogin=="" || this.settings.prefPassword=="")
		{
			alert(this.stringbundle.GetStringFromName("loginpasswordempty"));
			return false;
		}
		
	  var urlTmp = this.settings.prefUrl+"?l="+this.settings.prefLogin+"&p="+this.settings.prefPassword;	
/*
		if (this.settings.prefIsUploader)
			urlTmp = urlTmp+"&isuploader=1";
		else
			urlTmp = urlTmp+"&isuploader=0";
*/
		//alert(urlTmp);
	  	
		window.setCursor("wait");
	  	
		gBookmarksSynchronizerDownloadService.start(this._ioService.newURI(urlTmp, null, null), downloadCallback);

		return true;
  },
};

function uploadCallback(stat, err) 
{     
  if (stat=="done")
  {
		window.setCursor("auto");
		if (err==0)
		{
			var rien = confirm(gMemotooThunderbird.stringbundle.GetStringFromName("uploadok"));
			gMemotooThunderbird.settings.prefIsUploader = true;
		}
  }

  switch (err) 
  {
    case -2:
      break;
    case 0:
      break;
    case -3:
      break;
    case 401:
    	alert(gMemotooThunderbird.stringbundle.GetStringFromName("loginpassworderror"));
      break;
    default:
      break;
  }

  //setTimeout(close, 10000);
}

function downloadCallback(stat, err) 
{     
  if (stat=="done") 
  { 	
		window.setCursor("auto");    

		if (err==0)
		{
			// Copier les donnes dans un fichier en local
			var addressBookLDIFtmp = gBookmarksSynchronizerDownloadService.data;
			//alert(addressBookLDIFtmp);
	
	    var fichierTmp = Components.classes["@mozilla.org/file/directory_service;1"]
	                     .getService(Components.interfaces.nsIProperties)
	                     .get("TmpD", Components.interfaces.nsIFile);
			fichierTmp.append("addressBook-memotoo.ldif");
			//alert("->"+fichierTmp.path);
	
	    if (! fichierTmp.exists()) 
	    {
	      fichierTmp.create(0, 0644);
	    }
	
	    // set up the output stream to the file
	    var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
	    outputStream.init(fichierTmp, 0x20 | 0x02, 00004, null);
	
	    // write the HTML source to the file
	    var result = outputStream.write(addressBookLDIFtmp, addressBookLDIFtmp.length);
	    outputStream.flush();
	    outputStream.close();
	
			// Importation des favoris
			AddressBookCommandMemotoo.ImportAddress(fichierTmp.path);
			
			var rien = confirm(gMemotooThunderbird.stringbundle.GetStringFromName("downloadok"));
			gMemotooThunderbird.settings.prefIsDownloader = true;
		}
	}

  switch (err) 
  {
    case -2:
      break;
    case 0:
      break;
    case -3:
      break;
    case 401:
    	alert(gMemotooThunderbird.stringbundle.GetStringFromName("loginpassworderror"));
      break;
    default:
      break;
  }

  //setTimeout(close, 10000);
}